{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnVerEnhanceFrm;
{ |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* Ԫƣ汾ϢչõԪ
* Ԫߣʡhubdog
*     ע
* ƽ̨JWinXPPro + Delphi 7.01
* ݲԣJWinXPPro+ Delphi 7.01
*   õԪеֱַ֧ػʽ
* ޸ļ¼2019.03.26 V1.1 by liuxiao
*               뽫Ϊ汾ŵ
*           2005.05.05 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnWizards.inc}

{$IFDEF CNWIZARDS_CNVERENHANCEWIZARD}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, CnWizMultiLang, StdCtrls;

type
  TCnVerEnhanceForm = class(TCnTranslateForm)
    grpVerEnh: TGroupBox;
    chkLastCompiled: TCheckBox;
    chkIncBuild: TCheckBox;
    btnOK: TButton;
    btnCancel: TButton;
    btnHelp: TButton;
    lblNote: TLabel;
    lblFormat: TLabel;
    cbbFormat: TComboBox;
    chkDateAsVersion: TCheckBox;
    procedure btnHelpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkLastCompiledClick(Sender: TObject);
    procedure chkIncBuildClick(Sender: TObject);
  private
    { Private declarations }
  protected
    function GetHelpTopic: string; override;    
  public
    { Public declarations }
  end;

{$ENDIF CNWIZARDS_CNVERENHANCEWIZARD}

implementation

{$IFDEF CNWIZARDS_CNVERENHANCEWIZARD}

{$R *.dfm}

procedure TCnVerEnhanceForm.btnHelpClick(Sender: TObject);
begin
  ShowFormHelp;
end;

function TCnVerEnhanceForm.GetHelpTopic: string;
begin
  Result := 'CnVerEnhanceWizard';
end;

procedure TCnVerEnhanceForm.FormCreate(Sender: TObject);
begin
{$IFNDEF COMPILER6_UP}
  chkLastCompiled.Enabled := False;
  chkIncBuild.Enabled := False;
  lblFormat.Enabled := False;
  cbbFormat.Enabled := False;
  chkDateAsVersion.Enabled := False;
{$ELSE}
  lblFormat.Enabled := chkLastCompiled.Checked;
  cbbFormat.Enabled := chkLastCompiled.Checked;
  chkDateAsVersion.Enabled := chkIncBuild.Checked;
{$ENDIF}
end;

procedure TCnVerEnhanceForm.chkLastCompiledClick(Sender: TObject);
begin
  lblFormat.Enabled := chkLastCompiled.Checked;
  cbbFormat.Enabled := chkLastCompiled.Checked;
end;

procedure TCnVerEnhanceForm.chkIncBuildClick(Sender: TObject);
begin
  chkDateAsVersion.Enabled := chkIncBuild.Checked;
end;

{$ENDIF CNWIZARDS_CNVERENHANCEWIZARD}
end.

